
;---------------------------------------------------------------------------
; Searching of multiple ROM functions
;---------------------------------------------------------------------------


        include "doorsos.h"
        include "util.h"
	xdef _ti92plus
        xdef _main
        xdef _comment

; ROM 1.x screen is at $4440
ofs		equ	$4440
; ROM also at $200000
ROMSTART	equ	$200000

FIND_FUNCTION   MACRO
; Call:    FIND_FUNCTION start,end,fctname
        lea     \1(PC),a3
        move.w  #\2-\1-1,d2
        lea     \3(PC),a5
        bsr     search
        ENDM

_main:
	jsr	util::zap_screen
        move.w  #4,-(a7)
        pea     pos(PC)
        move.w  #100,-(a7)
        move.w  #10,-(a7)
        jsr     doorsos::DrawStrXY
        lea     10(a7),a7

        move.l  #ROMSTART,a0
        move.l  $C4(a0),d0              ; ROM size - 4
        move.l  a0,a1
	add.l	d0,a1
	lea	LCD_MEM,a5
	lea	30*127-4(a5),a5
	move.l	#$FFFF0000,(a5)
	clr.w	d7

        FIND_FUNCTION  __stuff_start,__stuff_end,NG_EXEC
        FIND_FUNCTION  __stuff_start2,__stuff_end2,HLOCK

        jsr     util::idle_loop
        rts


; Subfunction search
; Parameters    a3, start
;               a5, fctname
;               d2, size
;               d3, screen offset (y coordinate)
search:
	tst.w	doorsos::kb_globals+$1C
	bne	EndPrgm
	add.w	#1,d7
	cmp.w	#32768,d7
	bne	Next
	clr.w	d7
	move.l	(a5),d6
	rol.l	#1,d6
	move.l	d6,(a5)
Next:
        lea     __stuff_start(PC),a3
        move.w  #__stuff_end-__stuff_start-1,d2
        cmpa.l  a0,a1
        beq     NotFound
        move.l  a0,a4
        lea     1(a0),a0
compare:
        cmp.b   (a3)+,(a4)+
        bne     search
        dbra.w  d2,compare

        movem.l d3,-(a7)
        lea     -1(a0),a0
        move.l  a5,-(a7)
        move.l  a0,-(a7)
        pea     _found_msg(PC)
        pea     buffer(PC)
        jsr     doorsos::sprintf
        lea     16(a7),a7
        move.l  (a7)+,d3

        move.w  #4,-(a7)
        pea     buffer(PC)
        move.w  d3,-(a7)
        move.w  #10,-(a7)
        jsr     doorsos::DrawStrXY
        lea     10(a7),a7
        rts

NotFound:
        move.w  #4,-(a7)
        pea     nfound_msg(PC)
        move.w  d3,-(a7)
        move.w  #10,-(a7)
        jsr     doorsos::DrawStrXY
        lea     10(a7),a7
EndPrgm:
	rts

__stuff_start:
        INCLUDE "this.asm"
__stuff_end:

__stuff_start2:
	INCLUDE "this2.asm"
__stuff_end2:


pos		dc.b "This will take some minutes...",0
NG_EXEC         dc.b "doorsos::NG_execute",0
HLOCK           dc.b "doorsos::HLock",0
nfound_msg      dc.b "fct %s not found?",0
_found_msg      dc.b "fct %s is at %lx",0
buffer          ds.b 30
_comment dc.b "rom fct finder",0
        ENd
